const validate_budget_price = (rule, value, callback) => {
  if (value === "") {
    callback(new Error("预算单价不能为空！"));
  } else if (
    value === "0" ||
    value === "0." ||
    value === "0.0" ||
    value === "0.00"
  ) {
    callback(new Error("预算单价不能为零！"));
  } else {
    callback();
  }
};
const validate_num = (rule, value, callback) => {
  if (value === "") {
    callback(new Error("购买数量不能为空！"));
  } else if (
    value === "0") {
    callback(new Error("购买数量不能为零！"));
  } else {
    callback();
  }
};
const validate_total_weight = (rule, value, callback) => {
  if (value === "") {
    callback(new Error("商品重量不能为空！"));
  } else if (
    value === "0" ||
    value === "0." ||
    value === "0.0" ||
    value === "0.00" ||
    value === "0.000"
  ) {
    callback(new Error("商品重量不能为零！"));
  } else {
    callback();
  }
};
const validate_specs_weight = (rule, value, callback) => {
  if (value === "") {
    callback(new Error("金属克重不能为空！"));
  } else if (
    value === "0" ||
    value === "0." ||
    value === "0.0" ||
    value === "0.00" ||
    value === "0.000") {
    callback(new Error("金属克重不能为零！"));
  } else {
    callback();
  }
};
const rules = {
  arrival_time: [
    {
      required: true,
      message: "到货时间不能为空",
      trigger: "change",
    },
  ],
  budget_price: [
    {
      required: true,
      validator: validate_budget_price,
      trigger: "change",
    },
  ],
  num: [
    {
      required: true,
      validator: validate_num,
      trigger: "change",
    },
  ],
  brand_id: [
    {
      type: "array",
      required: true,
      message: "请选择品牌",
      trigger: "change",
    },
  ],
  unit: [
    {
      type: "array",
      required: true,
      message: "请选择单位",
      trigger: "change",
    },
  ],
  cat_id: [
    {
      type: "array",
      required: true,
      message: "请选择商品分类",
      trigger: "change",
    },
  ],
  good_img: [
    {
      required: true,
      message: "商品图片不能为空",
      trigger: "change",
    },
  ],
  good_name: [
    { required: true, message: "商品名称不能为空", trigger: "blur" },
  ],

  model: [
    {
      required: true,
      message: "型号不能为空",
      trigger: "blur",
    },
  ],
  color: [
    {
      required: true,
      message: "颜色不能为空",
      trigger: "blur",
    },
  ],
  material: [
    {
      required: true,
      message: "材质不能为空",
      trigger: "blur",
    },
  ],
  total_weight: [
    {
      required: true,
      validator: validate_total_weight,
      trigger: "blur",
    },
  ],
  is_addrs: [
    {
      required: true,
      message: "请选择是否多地",
      trigger: "change",
    },
  ],
  is_custom: [
    {
      required: true,
      message: "请选择是否定制",
      trigger: "change",
    },
  ],
  is_gold_price: [
    {
      required: true,
      message: "请选择是否启用实时金价",
      trigger: "change",
    },
  ],
  config: [
    {
      required: true,
      type: "array",
      message: "至少选择一个配置",
      trigger: "change",
    },
  ],
  specs_weight: [
    {
      required: true,
      validator: validate_specs_weight,
      trigger: "blur",
    },
  ],
  other_config: [
    {
      required: true,
      message: "其他要求不能为空",
      trigger: "blur",
    },
  ],
  cost_desc: [
    {
      required: true,
      message: "工艺说明不能为空",
      trigger: "blur",
    },
  ],
  use_desc: [
    {
      required: true,
      message: "产品用途不能为空",
      trigger: "blur",
    },
  ],
  remark: [
    {
      required: true,
      message: "商品备注不能为空",
      trigger: "blur",
    },
  ],
  metal_id: [
    {
      required: true,
      message: "贵金属种类不能为空",
      trigger: "blur",
    },
  ],
  gold_price: [
    {
      required: true,
      message: "当前金价不能为空",
      trigger: "blur",
    },
  ],
};
const edutRules = {
  companyNo: [
    {
      required: true,
      message: "请选择销售方公司",
      trigger: "change",
    },
  ],
  khNo: [
    {
      type: "array",
      required: true,
      message: "请选择购买方公司",
      trigger: "change",
    },
  ],
  platform_code: [
    {
      type: "array",
      required: true,
      message: "请选择所属平台",
      trigger: "change",
    },
  ],
  endtime: [
    {
      required: true,
      message: "咨询截止时间不能为空",
      trigger: "change",
    },
  ],

  is_project: [
    {
      required: true,
      message: "请选择咨询类型！",
      trigger: "change",
    },
  ],
  projectNo: [
    {
      type: "array",
      required: true,
      message: "请选择项目",
      trigger: "change",
    },
  ],
  arrival_time: [
    {
      required: true,
      message: "到货时间不能为空",
      trigger: "change",
    },
  ],
  budget_price: [
    {
      required: true,
      validator: validate_budget_price,
      trigger: "change",
    },
  ],
  num: [
    {
      required: true,
      validator: validate_num,
      trigger: "change",
    },
  ],
  brand_id: [
    {
      type: "array",
      required: true,
      message: "请选择品牌",
      trigger: "change",
    },
  ],
  unit: [
    {
      type: "array",
      required: true,
      message: "请选择单位",
      trigger: "change",
    },
  ],
  cat_id: [
    {
      type: "array",
      required: true,
      message: "请选择商品分类",
      trigger: "change",
    },
  ],
  good_img: [
    {
      required: true,
      message: "商品图片不能为空",
      trigger: "change",
    },
  ],
  good_name: [
    { required: true, message: "商品名称不能为空", trigger: "blur" },
  ],

  model: [
    {
      required: true,
      message: "型号不能为空",
      trigger: "blur",
    },
  ],
  color: [
    {
      required: true,
      message: "颜色不能为空",
      trigger: "blur",
    },
  ],
  material: [
    {
      required: true,
      message: "材质不能为空",
      trigger: "blur",
    },
  ],
  total_weight: [
    {
      required: true,
      validator: validate_total_weight,
      trigger: "blur",
    },
  ],
  is_addrs: [
    {
      required: true,
      message: "请选择是否多地",
      trigger: "change",
    },
  ],
  is_custom: [
    {
      required: true,
      message: "请选择是否定制",
      trigger: "change",
    },
  ],
  is_gold_price: [
    {
      required: true,
      message: "请选择是否启用实时金价",
      trigger: "change",
    },
  ],
  config: [
    {
      required: true,
      type: "array",
      message: "至少选择一个配置",
      trigger: "change",
    },
  ],
  specs_weight: [
    {
      required: true,
      validator: validate_specs_weight,
      trigger: "blur",
    },
  ],
  other_config: [
    {
      required: true,
      message: "其他要求不能为空",
      trigger: "blur",
    },
  ],
  cost_desc: [
    {
      required: true,
      message: "工艺说明不能为空",
      trigger: "blur",
    },
  ],
  use_desc: [
    {
      required: true,
      message: "产品用途不能为空",
      trigger: "blur",
    },
  ],
  remark: [
    {
      required: true,
      message: "商品备注不能为空",
      trigger: "blur",
    },
  ],
  metal_id: [
    {
      required: true,
      message: "贵金属种类不能为空",
      trigger: "blur",
    },
  ],
  gold_price: [
    {
      required: true,
      message: "当前金价不能为空",
      trigger: "blur",
    },
  ],
};
const feedbackListCol = [
  {
    prop: "zxNo",
    label: "咨询编号",
    width: "160"
  },
  {
    prop: "good_img",
    label: "图片",
    _slot_: "good_img",
    "width": "50"
  },
  {
    prop: "good_name",
    label: "商品名称",
    "width": "100"
  },
  {
    prop: "sale_price",
    label: "销售单价",
    "width": "100"
  },
  {
    prop: "status",
    label: "状态",
    _slot_: "status",
    width: "120px",
  },
  {
    prop: "expire_day",
    label: "信息有效期",
    "width": "100"
  },
  {
    prop: "model",
    label: "型号",
    "width": "80"
  },
  {
    prop: "color",
    label: "颜色",
    "width": "80"
  },
  {
    prop: "material",
    label: "材质",
    "width": "80"
  },



  {
    prop: "addtime",
    label: "添加时间",
    width: 142,
  },
  {
    prop: "",
    label: "操作",
    fixed: "right",
    _noset_: true,
    _slot_: "operation",
    width: 50,
  },
]

const listCol = [
  {
    prop: "zxNo",
    label: "咨询编号",
    width: "160"
  },
  {
    prop: "creater",
    label: "申请人",
    width: "60"
  },
  {
    prop: "good_name",
    label: "商品名称",
    "width": "100"
  },
  {
    prop: "good_img",
    label: "图片",
    _slot_: "good_img",
    "width": "50"
  },
  {
    prop: "status",
    label: "状态",
    _slot_: "status",
    width: "120px",
  },

  {
    prop: "khNo",
    label: "客户编号",
    "width": "125"
  },
  {
    prop: "khname",
    label: "客户名称",
    "width": "135"
  },

  {
    prop: "except_code",
    label: "预算单价",
    _slot_: "except_code",
    width: 110,

  },



  {
    prop: "addtime",
    label: "添加时间",
    width: 142,
  },
  {
    prop: "",
    label: "操作",
    fixed: "right",
    _noset_: true,
    _slot_: "operation",
    width: 50,
  },
]



export { listCol, rules, edutRules, feedbackListCol }